CCfits: CCfits::ExtHDU Class Reference

CCfits 2.7

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Classes | Public Member Functions | Static Public Member Functions | Protected Member Functions
CCfits::ExtHDU Class Reference

base class for all FITS extension HDUs, i.e. Image Extensions and Tables. More...

`#include <ExtHDU.h>`

Inheritance diagram for CCfits::ExtHDU:

List of all members.

## Classes
class | WrongExtensionType
| Exception to be thrown on unmatched extension types. More...
## Public Member Functions
| ExtHDU (const ExtHDU &right)
| copy constructor
virtual | ~ExtHDU ()
| destructor
virtual void | addColumn (ValueType type, const String &columnName, long repeatWidth, const String &colUnit=String(""), long decimals=-1, size_t columnNumber=0)
| add a new column to an existing table HDU.
virtual HDU * | clone (FITS *p) const =0
| virtual copy constructor
virtual Column & | column (const String &colName, bool caseSensitive=true) const
| return a reference to a Table column specified by name.
virtual Column & | column (int colIndex) const
| return a reference to a Table column specified by column index.
virtual const ColMap & | column () const
| return a reference to the multimap containing the columns.
virtual void | copyColumn (const Column &inColumn, int colIndx, bool insertNewCol=true)
| copy a column (from different or same HDU and file) into an existing table HDU.
virtual void | deleteColumn (const String &columnName)
| delete a column in a Table extension by name.
virtual long | getRowsize () const
| return the optimal number of rows to read or write at a time
bool | isCompressed () const
| return true if image is stored using compression.
virtual void | makeThisCurrent () const
| move the fitsfile pointer to this current HDU.
const String & | name () const
| return the name of the extension.
virtual int | numCols () const
| return the number of Columns in the Table (the TFIELDS keyword).
template<typename S >
void | read (std::valarray< S > &image)
| Read image data into container.
template<typename S >
void | read (std::valarray< S > &image, long first, long nElements, S *nullValue)
| read part of an image array, processing null values.
template<typename S >
void | read (std::valarray< S > &image, const std::vector< long > &first, long nElements, S *nullValue)
| read part of an image array, processing null values.
template<typename S >
void | read (std::valarray< S > &image, const std::vector< long > &firstVertex, const std::vector< long > &lastVertex, const std::vector< long > &stride)
| read an image subset
template<typename S >
void | read (std::valarray< S > &image, long first, long nElements)
| read an image section starting at a specified pixel
template<typename S >
void | read (std::valarray< S > &image, const std::vector< long > &first, long nElements)
| read an image section starting at a location specified by an n-tuple
template<typename S >
void | read (std::valarray< S > &image, const std::vector< long > &firstVertex, const std::vector< long > &lastVertex, const std::vector< long > &stride, S *nullValue)
| read an image subset into valarray image, processing null values
virtual void | readData (bool readFlag=false, const std::vector< String > &keys=std::vector< String >())=0
| read data from HDU depending on readFlag and keys.
virtual long | rows () const
| return the number of rows in the extension.
int | version () const
| return the extension version number.
void | version (int value)
| set the extension version number
template<typename S >
void | write (const std::vector< long > &first, long nElements, const std::valarray< S > &data, S *nullValue)
| Write a set of pixels to an image extension with the first pixel specified by an n-tuple, processing undefined data.
template<typename S >
void | write (long first, long nElements, const std::valarray< S > &data, S *nullValue)
| write array to image starting with a specified pixel and allowing undefined data to be processed
template<typename S >
void | write (const std::vector< long > &first, long nElements, const std::valarray< S > &data)
| write array starting from specified n-tuple, without undefined data processing
template<typename S >
void | write (long first, long nElements, const std::valarray< S > &data)
| write array starting from specified pixel number, without undefined data processing
template<typename S >
void | write (const std::vector< long > &firstVertex, const std::vector< long > &lastVertex, const std::valarray< S > &data)
| write a subset (generalize slice) of data to the image
## Static Public Member Functions
static void | readHduName (const fitsfile *fptr, int hduIndex, String &hduName, int &hduVersion)
| read extension name.
## Protected Member Functions
| ExtHDU (FITS *p, HduType xtype, const String &hduName, int version)
| default constructor, required as Standard Library Container content.
| ExtHDU (FITS *p, HduType xtype, const String &hduName, int bitpix, int naxis, const std::vector< long > &axes, int version)
| writing constructor.
| ExtHDU (FITS *p, HduType xtype, int number)
| ExtHDU constructor for getting ExtHDUs by number.
long | gcount () const
| return required gcount keyword value
void | gcount (long value)
| set required gcount keyword value
long | pcount () const
| return required pcount keyword value
void | pcount (long value)
| set required pcount keyword value
HduType | xtension () const
| return the extension type
void | xtension (HduType value)
| set the extension type

## Detailed Description

base class for all FITS extension HDUs, i.e. Image Extensions and Tables.

ExtHDU needs to have the combined public interface of Table objects and images. It achieves this by providing the same set of read and write operations as PHDU, and also providing the same operations for extracting columns from the extension as does Table [after which the column interface is accessible]. Differentiation between extension types operates by exception handling: .i.e. attempting to access image data structures on a Table object through the ExtHDU interface will or trying to return a Column reference from an Image extension will both throw an exception

## Constructor & Destructor Documentation

CCfits::ExtHDU::ExtHDU | ( | FITS * | p,
|  | HduType | xtype,
|  | const String & | hduName,
|  | int | bitpix,
|  | int | naxis,
|  | const std::vector< long > & | axes,
|  | int | version
| ) |  | `[protected]`

writing constructor.

The writing constructor forces the user to supply a name for the HDU. The bitpix, naxes and naxis data required by this constructor are required FITS keywords for any HDUs.

CCfits::ExtHDU::ExtHDU | ( | FITS * | p,
|  | HduType | xtype,
|  | int | number
| ) |  | `[protected]`

ExtHDU constructor for getting ExtHDUs by number.

Necessary since EXTNAME is a reserved, not required, keyword. But a synthetic name is supplied by static ExtHDU::readHduName which is called by this constructor.

## Member Function Documentation

void CCfits::ExtHDU::addColumn | ( | ValueType | type,
|  | const String & | columnName,
|  | long | repeatWidth,
|  | const String & | colUnit = `String("")`,
|  | long | decimals = `-1`,
|  | size_t | columnNumber = `0`
| ) |  | `[virtual]`

add a new column to an existing table HDU.

Parameters:

  type | The data type of the column to be added
  columnName | The name of the column to be added
  repeatWidth | for a string valued, this is the width of a string. For a numeric column it supplies the vector length of the rows. It is ignored for ascii table numeric data.
  colUnit | an optional field specifying the units of the data (TUNITn)
  decimals | optional parameter specifying the number of decimals for an ascii numeric column
  columnNumber | optional parameter specifying column number to be created. If not specified the column is added to the end. If specified, the column is inserted and the columns already read are reindexed. This parameter is provided as a convenience to support existing code rather than recommended.

Reimplemented in CCfits::AsciiTable, and CCfits::BinTable.

Column & CCfits::ExtHDU::column | ( | const String & | colName,
|  | bool | caseSensitive = `true`
| ) |  | const`[virtual]`

return a reference to a Table column specified by name.

If the caseSensitive parameter is set to false, the search will be case-insensitive. The overridden base class implementation ExtHDU::column throws an exception, which is thus the action to be taken if self is an image extension

Exceptions:

  WrongExtensionType | see above

Reimplemented in CCfits::Table.

Column & CCfits::ExtHDU::column | ( | int | colIndex | ) | const`[virtual]`

return a reference to a Table column specified by column index.

This version is provided for convenience; the 'return by name' version is more efficient because columns are stored in an associative array sorted by name.

Exceptions:

  WrongExtensionType | thrown if *this is an image extension.

Reimplemented in CCfits::Table.

const ColMap & CCfits::ExtHDU::column | ( |  | ) | const`[virtual]`

return a reference to the multimap containing the columns.

Exceptions:

  WrongExtensionType | thrown if *this is an image extension.

Reimplemented in CCfits::Table.

void CCfits::ExtHDU::copyColumn | ( | const Column & | inColumn,
|  | int | colIndx,
|  | bool | insertNewCol = `true`
| ) |  | `[virtual]`

copy a column (from different or same HDU and file) into an existing table HDU.

This is meant to provide the same functionality as CFITSIO's fits_copy_col, and therefore does not work with columns with variable length fields. Copying a column from an AsciiTable to a BinTable is prohibited. colIndx range should be from 1 to nCurrentCols+1 if inserting, or 1 to nCurrentCols if replacing.

Parameters:

  inColumn | The Column object which is to be copied
  colIndx | The position for which the copied Column will be placed (first colIndx = 1).
  insertNewCol | If 'true', new Column will be inserted in or appended to table. If 'false', Column will replace current Column at position = colIndx.

Reimplemented in CCfits::Table.

void CCfits::ExtHDU::deleteColumn | ( | const String & | columnName | ) | `[virtual]`

delete a column in a Table extension by name.

Parameters:

  columnName | The name of the column to be deleted.

Exceptions:

  WrongExtensionType | if extension is an image.

Reimplemented in CCfits::Table.

long CCfits::ExtHDU::getRowsize | ( |  | ) | const`[virtual]`

return the optimal number of rows to read or write at a time

A wrapper for the CFITSIO function fits_get_rowsize, useful for obtaining maximum I/O efficiency. This will throw if it is not called for a Table extension.

Reimplemented in CCfits::Table.

bool CCfits::ExtHDU::isCompressed | ( |  | ) | const

return true if image is stored using compression.

This is simply a wrapper around the CFITSIO fits_is_compressed_image function. It will throw if this is not an Image extension.

void CCfits::ExtHDU::makeThisCurrent | ( |  | ) | const`[virtual]`

move the fitsfile pointer to this current HDU.

This function should never need to be called by the user since it is called internally whenever required.

Reimplemented from CCfits::HDU.

int CCfits::ExtHDU::numCols | ( |  | ) | const`[virtual]`

return the number of Columns in the Table (the TFIELDS keyword).

Exceptions:

  WrongExtensionType | thrown if *this is an image extension.

Reimplemented in CCfits::Table.

template<typename S >

void CCfits::ExtHDU::read | ( | std::valarray< S > & | image | ) |

Read image data into container.

The container image contains the entire image array after the call. This and all the other variants of read() throw a WrongExtensionType exception if called for a Table object.

template<typename S >

void CCfits::ExtHDU::read | ( | std::valarray< S > & | image,
|  | long | first,
|  | long | nElements,
|  | S * | nullValue
| ) |  |

read part of an image array, processing null values.

Implicit data conversion is supported (i.e. user does not need to know the type of the data stored. A WrongExtensionType extension is thrown if *this is not an image.

Parameters:

  image | The receiving container, a std::valarray reference
  first | The first pixel from the array to read [a long value]
  nElements | The number of values to read
  nullValue | A pointer containing the value in the table to be considered as undefined. See cfitsio for details

template<typename S >

void CCfits::ExtHDU::read | ( | std::valarray< S > & | image,
|  | const std::vector< long > & | first,
|  | long | nElements,
|  | S * | nullValue
| ) |  |

read part of an image array, processing null values.

As above except for

Parameters:

  first | a vector<long> representing an n-tuple giving the coordinates in the image of the first pixel.

template<typename S >

void CCfits::ExtHDU::read | ( | std::valarray< S > & | image,
|  | const std::vector< long > & | firstVertex,
|  | const std::vector< long > & | lastVertex,
|  | const std::vector< long > & | stride,
|  | S * | nullValue
| ) |  |

read an image subset into valarray image, processing null values

The image subset is defined by two vertices and a stride indicating the 'denseness' of the values to be picked in each dimension (a stride = (1,1,1,...) means picking every pixel in every dimension, whereas stride = (2,2,2,...) means picking every other value in each dimension.

static void CCfits::ExtHDU::readHduName | ( | const fitsfile * | fptr,
|  | int | hduIndex,
|  | String & | hduName,
|  | int & | hduVersion
| ) |  | `[static]`

read extension name.

Used primarily to allow extensions to be specified by HDU number and provide their name for the associative array that contains them. Alternatively, if there is no name keyword in the extension, one is synthesized from the index.

long CCfits::ExtHDU::rows | ( |  | ) | const`[virtual]`

return the number of rows in the extension.

Exceptions:

  WrongExtensionType | thrown if *this is an image extension.

Reimplemented in CCfits::Table.

template<typename S >

void CCfits::ExtHDU::write | ( | const std::vector< long > & | first,
|  | long | nElements,
|  | const std::valarray< S > & | data,
|  | S * | nullValue
| ) |  |

Write a set of pixels to an image extension with the first pixel specified by an n-tuple, processing undefined data.

All the overloaded versions of ExtHDU::write perform operations on *this if it is an image and throw a WrongExtensionType exception if not. Where appropriate, alternate versions allow undefined data to be processed

Parameters:

  first | an n-tuple of dimension equal to the image dimension specifying the first pixel in the range to be written
  nElements | number of pixels to be written
  data | array of data to be written
  nullValue | pointer to null value (data with this value written as undefined; needs the BLANK keyword to have been specified).

template<typename S >

void CCfits::ExtHDU::write | ( | long | first,
|  | long | nElements,
|  | const std::valarray< S > & | data,
|  | S * | nullValue
| ) |  |

write array to image starting with a specified pixel and allowing undefined data to be processed

parameters after the first are as for version with n-tuple specifying first element. these two version are equivalent, except that it is possible for the first pixel number to exceed the range of 32-bit integers, which is how long datatype is commonly implemented.

template<typename S >

void CCfits::ExtHDU::write | ( | const std::vector< long > & | firstVertex,
|  | const std::vector< long > & | lastVertex,
|  | const std::valarray< S > & | data
| ) |  |

write a subset (generalize slice) of data to the image

A generalized slice/subset is a subset of the image (e.g. one plane of a data cube of size <= the dimension of the cube). It is specified by two opposite vertices. The equivalent cfitsio call does not support undefined data processing so there is no version that allows a null value to be specified.

Parameters:

  firstVertex | the coordinates specifying lower and upper vertices of the n-dimensional slice
  lastVertex |
  data | The data to be written

HduType CCfits::ExtHDU::xtension | ( |  | ) | const`[inline, protected]`

return the extension type

allowed values are ImageHDU, AsciiTbl, and BinaryTbl

The documentation for this class was generated from the following files:

- ExtHDU.h
- ExtHDU.cxx
- ExtHDUT.h